// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIPars.pas' rev: 3.00

#ifndef SMIParsHPP
#define SMIParsHPP
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smipars
{
//-- type declarations -------------------------------------------------------
enum TTokenType { ttNone, ttString, ttNumeric, ttDateTime, ttParenthesis, ttOperation, ttParamDelimitor 
	};

typedef void __fastcall (__closure *TOnEvaluate)(System::TObject* Sender, System::AnsiString Eval, const 
	System::Variant * Args, const int Args_Size, int ArgCount, bool IsChild, System::Variant &Value, bool 
	&Done);

class DELPHICLASS TExpToken;
class PASCALIMPLEMENTATION TExpToken : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FText;
	TTokenType FTokenType;
	
public:
	__property System::AnsiString Text = {read=FText};
	__property TTokenType TokenType = {read=FTokenType, nodefault};
public:
	/* TObject.Create */ __fastcall TExpToken(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TExpToken(void) { }
	
};

class DELPHICLASS TExpParser;
class PASCALIMPLEMENTATION TExpParser : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::AnsiString FExpression;
	Classes::TList* FTokens;
	int FPos;
	
private:
	void __fastcall Clear(void);
	TExpToken* __fastcall GetToken(int Index);
	void __fastcall SetExpression(const System::AnsiString Value);
	
public:
	__fastcall TExpParser(void);
	__fastcall virtual ~TExpParser(void);
	TExpToken* __fastcall ReadFirstToken(void);
	TExpToken* __fastcall ReadNextToken(void);
	int __fastcall TokenCount(void);
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property Classes::TList* TokenList = {read=FTokens};
	__property System::AnsiString Expression = {read=FExpression, write=SetExpression};
};

class DELPHICLASS TExpNode;
class PASCALIMPLEMENTATION TExpNode : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::TObject* FOwner;
	TExpNode* FParent;
	Classes::TList* FChildren;
	Classes::TList* FTokens;
	int FLevel;
	TExpToken* FToken;
	TOnEvaluate FOnEvaluate;
	
private:
	TExpToken* __fastcall GetToken(int Index);
	TExpNode* __fastcall GetChildren(int Index);
	int __fastcall FindLSOTI(void);
	bool __fastcall ParseFunction(void);
	void __fastcall RemoveSorroundingParenthesis(void);
	void __fastcall SplitToChildren(int TokenIndex);
	System::Variant __fastcall Evaluate();
	__property TExpNode* Children[int Index] = {read=GetChildren};
	
public:
	__fastcall TExpNode(System::TObject* AOwner, TExpNode* AParent, Classes::TList* Tokens);
	__fastcall virtual ~TExpNode(void);
	void __fastcall Build(void);
	int __fastcall TokenCount(void);
	System::Variant __fastcall Calculate();
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property TExpNode* Parent = {read=FParent};
	__property int Level = {read=FLevel, nodefault};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
};

class DELPHICLASS TSMIParser;
class PASCALIMPLEMENTATION TSMIParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FProcessBeforeEvent;
	System::AnsiString FText;
	TOnEvaluate FOnEvaluate;
	System::Variant FValue;
	
protected:
	void __fastcall Compile(bool ToCalculate);
	System::Variant __fastcall GetValue();
	void __fastcall Evaluate(System::AnsiString Eval, const System::Variant * Args, const int Args_Size
		, bool IsChild, System::Variant &Value);
	
public:
	__fastcall virtual TSMIParser(Classes::TComponent* AOwner);
	void __fastcall Validate(void);
	__property System::Variant Value = {read=GetValue};
	
__published:
	__property bool ProcessBeforeEvent = {read=FProcessBeforeEvent, write=FProcessBeforeEvent, nodefault
		};
	__property System::AnsiString Text = {read=FText, write=FText};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
public:
	/* TComponent.Destroy */ __fastcall virtual ~TSMIParser(void) { }
	
};

typedef System::Variant SMIPars__6[11];

class DELPHICLASS TSMIParserFunction;
class PASCALIMPLEMENTATION TSMIParserFunction : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::AnsiString FAsString;
	System::AnsiString FName;
	System::AnsiString FFunction;
	System::AnsiString FDescription;
	System::AnsiString FHint;
	System::TObject* FOwner;
	int FArgCount;
	Classes::TStringList* FArgs;
	System::Variant FValues[11];
	System::AnsiString FCategory;
	System::AnsiString FSubCategory;
	
private:
	void __fastcall SetAsString(const System::AnsiString Value);
	void __fastcall EvalArgs(System::TObject* Sender, System::AnsiString Eval, const System::Variant * 
		Args, const int Args_Size, int ArgCount, System::Variant &Value);
	
protected:
	void __fastcall ApplyArguments(const System::Variant * Values, const int Values_Size);
	
public:
	__fastcall TSMIParserFunction(System::TObject* AOwner);
	__fastcall virtual ~TSMIParserFunction(void);
	virtual System::Variant __fastcall Calculate();
	__property System::AnsiString AsString = {read=FAsString, write=SetAsString};
	__property System::AnsiString Name = {read=FName};
	__property int ArgCount = {read=FArgCount, nodefault};
	__property Classes::TStringList* Args = {read=FArgs};
	__property System::AnsiString Description = {read=FDescription, write=FDescription};
	__property System::AnsiString Hint = {read=FHint, write=FHint};
	__property System::AnsiString Category = {read=FCategory, write=FCategory};
	__property System::AnsiString SubCategory = {read=FSubCategory, write=FSubCategory};
};

class DELPHICLASS TSMIParserFunctions;
class PASCALIMPLEMENTATION TSMIParserFunctions : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TSMIParserFunctions(void);
	TSMIParserFunction* __fastcall AddFunction(const System::AnsiString Value);
	HIDESBASE void __fastcall Remove(int Index);
	TSMIParserFunction* __fastcall GetFunction(int Index);
	TSMIParserFunction* __fastcall FunctionByName(System::AnsiString FuncName);
public:
	/* TObject.Create */ __fastcall TSMIParserFunctions(void) : Classes::TList() { }
	
};

enum TSMIParameterEditor { ipeEdit, ipeMemo, ipeCheckBox, ipeCombobox, ipeListBox };

enum TSMIParameterMode { ipmCalculate, ipmCalculateAndAsk, ipmAsk };

class DELPHICLASS TSMIParameter;
class PASCALIMPLEMENTATION TSMIParameter : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	System::AnsiString FCaption;
	System::AnsiString FDescription;
	System::AnsiString FExpression;
	TSMIParameterEditor FParameterEditor;
	TSMIParameterMode FParameterMode;
	Classes::TStrings* FParamPromptValues;
	bool FRequired;
	void __fastcall SetParamPromptValues(Classes::TStrings* Value);
	void __fastcall SetName(System::AnsiString Value);
	
public:
	System::Variant Value;
	__fastcall virtual TSMIParameter(Classes::TCollection* Collection);
	__fastcall virtual ~TSMIParameter(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::AnsiString Caption = {read=FCaption, write=FCaption};
	__property System::AnsiString Name = {read=FName, write=SetName};
	__property System::AnsiString Expression = {read=FExpression, write=FExpression};
	__property System::AnsiString Description = {read=FDescription, write=FDescription};
	__property Classes::TStrings* ParamPromptValues = {read=FParamPromptValues, write=SetParamPromptValues
		};
	__property TSMIParameterEditor ParameterEditor = {read=FParameterEditor, write=FParameterEditor, default=0
		};
	__property TSMIParameterMode ParameterMode = {read=FParameterMode, write=FParameterMode, default=1}
		;
	__property bool Required = {read=FRequired, write=FRequired, default=0};
};

class DELPHICLASS TSMIParameters;
class PASCALIMPLEMENTATION TSMIParameters : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMIControl;
	TSMIParameter* __fastcall GetParameter(int Index);
	void __fastcall SetParameter(int Index, TSMIParameter* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMIParameters(Classes::TComponent* SMICntrl);
	HIDESBASE TSMIParameter* __fastcall Add(void);
	TSMIParameter* __fastcall ParamByName(const System::AnsiString Value);
	__property Classes::TComponent* SMIControl = {read=FSMIControl};
	__property TSMIParameter* Items[int Index] = {read=GetParameter, write=SetParameter/*, default*/};
public:
		
	/* TCollection.Destroy */ __fastcall virtual ~TSMIParameters(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define MAXPARAMCOUNT (Byte)(10)
extern PACKAGE TSMIParserFunctions* lstSMIRegFunctions;
extern PACKAGE System::TDateTime __fastcall GetDTByMask(System::AnsiString AValue, System::AnsiString 
	AFormat, char ADateSeparator, char ATimeSeparator);
extern PACKAGE System::AnsiString __fastcall GetNextItem(char chSeparator, System::AnsiString &s, bool 
	IsVal, bool IsLastToken);
extern PACKAGE bool __fastcall StringIsNumeric(System::AnsiString Value);
extern PACKAGE System::AnsiString __fastcall ReplaceStr(System::AnsiString s, System::AnsiString oldPattern
	, System::AnsiString newPattern, bool IgnoreCase, bool ReplaceAll);
extern PACKAGE System::WideString __fastcall ReplaceWideStr(System::WideString s, System::WideString 
	oldPattern, System::WideString newPattern, bool IgnoreCase, bool ReplaceAll);

}	/* namespace Smipars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smipars;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMIPars
